/*
 *	main.c
 *
 *	wNVIǂ
 *
 *	* Tue Dec 24 00:00:00 JST 2002 Naoyuki Sawa
 *	- 1st [X
 */
#include "app.h"

#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		30			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/* ]p^[F
 * +----------------+
 * |(00)   20   (40)|
 * |    10    30    |
 * | 01    21    41 |
 * |    11    31    |
 * | 02   (22)   42 |
 * |    12    32    |
 * | 03    23    43 |
 * |    13    33    |
 * |(04)   24   (44)|
 * |   (14)  (34)   |
 * +----------------+
 * 00,04,44,40
 */
const char rot_pos[3][6][2] = {
	{{1,0},{3,0},{4,2},{3,3},{1,3},{0,2}},
	{{0,1},{2,0},{4,1},{4,3},{2,4},{0,3}},
	{{1,1},{2,1},{3,1},{3,2},{2,3},{1,2}},
};

const int erase_pts[4 + 1] = {
	   0,	/* (g܂) */
	 200,	/* PC     */
	 500,	/* QC */
	1000,	/* RC */
	2000,	/* SC */
};

#define BLOCK_COLS	5
#define BLOCK_ROWS	5
typedef char BLOCK[BLOCK_ROWS][BLOCK_COLS];
BLOCK blocks[] = {
#define _	0
#define O	1
	//  +---+--ʏł͋񂪔L܂B
	//  |   |
	{{_,_,_,_,_}, //cNEXT\͂΂̍s͕\܂B
	 {_,_,O,_,_}, //  NEXT\͑S\܂B
	 {_,O,O,_,_}, //  ܂ASs~T̕\ƂȂ킯łB
	 {_,_,O,_,_},
	 {_,_,_,_,_}},
	{{_,_,_,_,_},
	 {_,_,O,_,_},
	 {_,_,O,O,_},
	 {_,_,O,_,_},
	 {_,_,_,_,_}},
	{{_,_,_,_,_},
	 {_,_,O,_,_},
	 {_,_,O,_,_},
	 {_,O,O,_,_},
	 {_,_,_,_,_}},
	{{_,_,_,_,_},
	 {_,_,O,_,_},
	 {_,_,O,_,_},
	 {_,_,O,O,_},
	 {_,_,_,_,_}},
	{{_,_,_,_,_},
	 {_,_,O,_,_},
	 {_,O,O,_,_},
	 {_,O,_,_,_},
	 {_,_,_,_,_}},
	{{_,_,_,_,_},
	 {_,_,O,_,_},
	 {_,_,O,O,_},
	 {_,_,_,O,_},
	 {_,_,_,_,_}},
	{{_,_,_,_,_},
	 {_,_,O,_,_},
	 {_,_,O,_,_},
	 {_,_,O,_,_},
	 {_,_,O,_,_}},
	{{_,_,_,_,_},
	 {_,_,_,_,_},
	 {_,O,O,O,_},
	 {_,_,O,_,_},
	 {_,_,_,_,_}},
	{{_,_,_,_,_},
	 {_,O,O,_,_},
	 {_,O,_,_,_},
	 {_,_,O,_,_},
	 {_,_,_,_,_}},
	{{_,_,_,_,_},
	 {_,_,O,_,_},
	 {_,O,O,O,_},
	 {_,_,_,_,_},
	 {_,_,_,_,_}},
#undef _
#undef O
};
#define N_BLOCKS	(sizeof blocks / sizeof *blocks)

#define FIELD_COLS	11	/* tB[h */
#define FIELD_ROWS	(20+5)	/* tB[hs(ʓ20{ʊO5) */
#define OUTER_ROWS	    5	/* ʊO̍s */

/* Q[ */
typedef struct _GI {
	int seed;		/* V[h */
	int score;		/* XRA */
	int lines;		/* C */
	int level;		/* x */
	int next;		/* NEXTubN̎ */
	BLOCK block;		/* ݂̃ubN */
	int col, row;		/* ݂̃ubN̈ʒu */
	int anm;		/* ėpAj[VJE^ */
	char field[FIELD_ROWS][FIELD_COLS]; /* tB[h */
} GI;

/* x` */
typedef struct _LEVEL {
	int next_line;		/* C玟̃xɐiނH */
	short fall_wait;	/* EFCg */
	char hint;		/* qg̗L */
	char blocks;		/* ubN̎ށiނ̏ox点邽߁j */
} LEVEL;
LEVEL levels[] = {
	{  5, SEC(1.0  ), 1, N_BLOCKS-2 },	/*  0 */
	{ 10, SEC(0.5  ), 1, N_BLOCKS-2 },	/*  1 */
	{ 15, SEC(0.25 ), 1, N_BLOCKS-2 },	/*  2 */
	{ 20, SEC(0.125), 1, N_BLOCKS-2 },	/*  3 */
	{ 30, SEC(0.05 ), 0, N_BLOCKS-2 },	/*  4 */
	{ 40, SEC(0.25 ), 0, N_BLOCKS-2 },	/*  5 */
	{ 50, SEC(0.125), 0, N_BLOCKS-2 },	/*  6 */
	{ 60, SEC(0.05 ), 0, N_BLOCKS-2 },	/*  7 */
	{ 70, SEC(0    ), 0, N_BLOCKS-2 },	/*  8 */
	{ 80, SEC(0.125), 0, N_BLOCKS   },	/*  9 */
	{ 90, SEC(0.05 ), 0, N_BLOCKS   },	/* 10 */
};
#define N_LEVELS	(sizeof levels / sizeof *levels)

/* ^C~O` */
#define FLOAT_WAIT	SEC(0.25)	/* o`܂ł̃EFCg */
//#define FALL_WAIT	SEC(0.25)	/* EFCgxƂɒ` */
#define FALL_WAIT	(gi.level < N_LEVELS ? levels[gi.level].fall_wait : 0)
#define LAND_WAIT	SEC(0.33)	/* n`ڒn܂ł̃EFCg */
#define LINE_WAIT1	SEC(0.80)	/* s̓_Ŏ */
#define LINE_WAIT2	SEC(0.20)	/* s̔\ */
#define NEXT_WAIT	SEC(0.33)	/* ڒn`NEXTo܂ł̃EFCg */
#define LEVEL_HINT	(gi.level < N_LEVELS ? levels[gi.level].hint : 0)
#define LEVEL_BLOCKS	(gi.level < N_LEVELS ? levels[gi.level].blocks : N_BLOCKS)

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

extern const unsigned char PAT[];
TEXTURE pat;
TEXTURE bg;

int hiscore;
int level_sel;
int bgm_sel;
GI gi;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
void cell_pos(int bcol, int brow, int ccol, int crow, int* fcol, int* frow);
void cell_disp(int col, int row, int type);
void block_disp(int col, int row, const BLOCK block, int type);
void center_disp(int col, int row, int type);
void next_cell_disp(int col, int row, int type);
void next_block_disp(const BLOCK block);
void block_rot(const BLOCK src, int rot, BLOCK dst);
int hit_test(int col, int row, const BLOCK block);
int land_test(int col, int row, const BLOCK block);
void block_put(int col, int row, const BLOCK block);
void block_work();
int line_test();
void line_erase();
void field_disp(int show_block);

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init(&render, &surface, 0, 0, 0, 0, 0, 0, 0);

	/* N[Abv֐o^B */
	atexit(app_exit);

/*{{AvP[VL̏*/
	turbo(1); /* S48MHz[h */
	srand(pceTimerGetCount());
	/* rbg}bvB */
	texture_init(&pat, PAT);
	pat.buf += DISP_X / 4; /* ubN_ */
	pat.mask += DISP_X / 8;
	texture_init(&bg, PAT);
	bg.header.mask = 0; /* wi`̓}XNȂ */
	bg.mask = NULL;
	render.context->texture = &pat;
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
	/* mMODt~܂B */
	mod_stop();
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
//#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

	/* wNVÍAEL[ɍI[gs[g܂B */
	{
		static unsigned char cnt[2];
		int i;
		for(i = 0; i < 2; i++) { /* ʂɃrbgPAD_LFAPAD_RI */
			if(joy & (0x01 << i)) {
				if(cnt[i] != 0xff) cnt[i]++;
				if(cnt[i] >= SEC(0.25)) joy |= (0x100 << i);
			} else {
				cnt[i] = 0;
			}
		}
	}

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int i, x, y, sel = 0;

	for(;;) {
		schedule();

		/* X^[gHIH */
		if(joy & TRG_A     ) break;
		if(joy & TRG_SELECT) return -1;

		/* ʍĕ`ȂŃvvĝݓ_ł邽߁AʃNAɔI */
		memset(vbuff, 3, sizeof vbuff);

		/* BGMEJnxIB */
		if(sel == 0) {
			if(joy & (TRG_LF) && bgm_sel == 1) { bgm_sel = 0; sound_play(1, ROT); }
			if(joy & (TRG_RI) && bgm_sel == 0) { bgm_sel = 1; sound_play(1, ROT); }
			if(joy & (TRG_DN)) { sel = 1; sound_play(1, ROT); }
		} else {
			if(joy & (TRG_LF) && level_sel >            0) { level_sel--; sound_play(1, ROT); }
			if(joy & (TRG_RI) && level_sel < N_LEVELS - 1) { level_sel++; sound_play(1, ROT); }
			if(joy & (TRG_UP)) { sel = 0; sound_play(1, ROT); }
		}

		/* ^Cg\B */
		x = (DISP_X - 8 * 6) / 2;
		y = 32;
		render_string_framed(&render, x, y, "HEXION", 1, 0x210);
		x = (DISP_X - 10 * 3) / 2;
		y += 14;
		render_string_framed(&render, x, y, "ǂ", 0, 0x210);

		/* XRA\B */
		x = 0;
		y = 0;
		render_string_framed(&render, x, y, "HISCORE", 0, 0x321);
		y += 10;
		render_printf_framed(&render, x, y, 0, 0x321, "%6d", hiscore <= 999999 ? hiscore : 999999);
		x = DISP_X - 5 * 7 - 3;
		y = 0;
		render_string_framed(&render, x, y, "PLAYER1", 0, 0x321);
		y += 10;
		render_printf_framed(&render, x, y, 0, 0x321, "%6d", gi.score <= 999999 ? gi.score : 999999);

		/* BGMEJnx\B */
		x = (DISP_X - 5 * 12) / 2;
		y = DISP_Y - 20;
		if(sel == 0) {
			render_printf_framed(&render, x, y, 0, 0x321, "<  BGM   %d >", bgm_sel + 1);
		} else {
			render_printf_framed(&render, x, y, 0, 0x332, "   BGM   %d  ", bgm_sel + 1);
		}
		y += 10;
		if(sel == 1) {
			render_printf_framed(&render, x, y, 0, 0x321, "< LEVEL %2d >", level_sel);
		} else {
			render_printf_framed(&render, x, y, 0, 0x332, "  LEVEL %2d  ", level_sel);
		}

		/* vvg\B */
		x = (DISP_X - 5 * 8) / 2;
		y = DISP_Y - 50;
		render_string_framed(&render, x, y, " A START", 0, 0x321);
		y += 10;
		render_string_framed(&render, x, y, "SEL EXIT", 0, 0x321);
	}

	sound_play(1, ERASE);

	/* vvg_ŁB */
	for(i = 0; i < SEC(1.5); i++) {
		schedule();
		x = (DISP_X - 5 * 8) / 2;
		y = DISP_Y - 50;
		render_string_framed(&render, x, y, " A START", 0, i % SEC(0.5) < SEC(0.25) ? 0x333 : 0x321);
	}

	return 0;
}

/****************************************************************************
 *	game
 ****************************************************************************/

static int
next_block_gen()
{
	return RND16(gi.seed) % LEVEL_BLOCKS;
}

static int
init_block_row(int col, const BLOCK block)
{
	int row, ccol, crow, fcol, frow;

	/* ȂƂ̃ZʊO̍ŉsɂȂ܂ŁAubN̏oʒu܂B */
	for(row = 0; row < OUTER_ROWS; row++) {
		for(crow = 0; crow < BLOCK_ROWS; crow++) {
			for(ccol = 0; ccol < BLOCK_COLS; ccol++) {
				if(block[crow][ccol]) {
					cell_pos(col, row, ccol, crow, &fcol, &frow);
					if(frow >= OUTER_ROWS - 1) return row;
				}
			}
		}
	}
	DIE(); /* ubNɃZȂH */
	return 0; /* _~[ */
}

void
game()
{
	int i, bgm, col, row, cnt;

	/* Q[B */
	memset(&gi, 0, sizeof gi);
	gi.seed = now;
	gi.level = level_sel;
	if(gi.level != 0) gi.lines = levels[gi.level - 1].next_line;
	gi.next = next_block_gen();

	/* ʏBGMX^[gB */
	pceWaveSetChAtt(0, 0); /* Q[I[o[Ɍ܂ */
	bgm = 0;
	if(bgm_sel == 0) { mod_play(BGMA); } else { mod_play(BGMB); }

	for(;;) {
		/* ΂̃ubNʒu𒲂ׂ܂B */
		for(row = 0; row < FIELD_ROWS; row++) {
			for(col = 0; col < FIELD_COLS; col++) {
				if(gi.field[row][col]) break;
			}
			if(col < FIELD_COLS) break;
		}

		/* ʊOɃubNQ[I[o[B */
		if(row < OUTER_ROWS) goto GAMEOVER;

		/* ʓ̏ォTsȓɃubNxBGMBȂΒʏBGMB */
		if(row < OUTER_ROWS + 5) {
			if(!bgm) {
				bgm = 1;
				mod_play(WARN);
			}
		} else {
			if(bgm) {
				bgm = 0;
				if(bgm_sel == 0) { mod_play(BGMA); } else { mod_play(BGMB); }
			}
		}

		/* VubN擾܂B */
		memcpy(gi.block, blocks[gi.next], sizeof(BLOCK));
		gi.next = next_block_gen();

		/* VubN̏ʒu܂B */
		gi.col = (FIELD_COLS - BLOCK_COLS) / 2;
		gi.row = init_block_row(gi.col, gi.block); /* ܂͉ʊO肬Ŏ擾 */
		if(!hit_test(gi.col, gi.row + 1, gi.block)) gi.row++; /* ZʓɓȂAʒuJn */

		/* o`Jn܂ł̈ړB */
		for(i = 0; i < FLOAT_WAIT; i++) {
			schedule();

			/* ړB */
			block_work();

			/* \B */
			field_disp(1);
			gi.anm++;

			/* nB */
			if(land_test(gi.col, gi.row, gi.block)) goto L_LAND;

			/* JnB */
			if(joy & TRG_DN) break;
		}
L_FALL:
		/* ̈ړB */
		for(i = 0; i <= FALL_WAIT; i++) {
			schedule();

			/* ړB */
			block_work();

			/* \B */
			field_disp(1);
			gi.anm++;

			/* nB */
			if(land_test(gi.col, gi.row, gi.block)) goto L_LAND;

			/* B */
			if(joy & PAD_DN) {
				/* XRAZB */
				gi.score++;
				break;
			}
		}
		gi.row++;
		goto L_FALL;
L_LAND:
		sound_play(2, LAND);

		/* n`ڒn܂ł̍EړB */
		for(i = 0; i <= LAND_WAIT; i++) {
			schedule();

			/* ړB */
			block_work();

			/* \B */
			field_disp(1);
			gi.anm++;

			/* nB */
			if(!land_test(gi.col, gi.row, gi.block)) goto L_FALL;
		}

		/* ubN̉܂B */
		block_put(gi.col, gi.row, gi.block);

		/* sH */
		cnt = line_test();
		if(cnt != 0) {
			sound_play(3, ERASE);

			/* Aj[VB */
			for(i = 0; i <= LINE_WAIT1; i++) {
				schedule();
				field_disp(0); /* ubN\Ȃ */
				gi.anm++;
			}

			/* Ԃŏ\B */
			for(row = 0; row < FIELD_ROWS; row++) {
				for(col = 0; col < FIELD_COLS; col++) {
					if(gi.field[row][col] == 2) gi.field[row][col] = 3;
				}
			}
			for(i = 0; i <= LINE_WAIT2; i++) {
				schedule();
				field_disp(0); /* ubN\Ȃ */
				gi.anm++;
			}

			/* ۂɏ܂B */
			line_erase();

			/* XRAZB */
			gi.score += erase_pts[cnt];

			/* CZAxXVB */
			gi.lines += cnt;
			while(gi.level < N_LEVELS) { /* x` */
				if(gi.lines < levels[gi.level].next_line) break;
				gi.level++;
			}
			if(gi.level >= N_LEVELS) { /* x`Ȃ */
				gi.level = N_LEVELS + (gi.lines - levels[N_LEVELS - 1].next_line) / 10;
			}

			sound_play(1, FALL); /* ̂ */
			sound_play(2, FALL); /* QchĐ */

			/* ŕ\XVĂȂƁAʂĂ܂B */
			field_disp(0); /* ubN\Ȃ */
			gi.anm++;
		}

		/* ڒn`NEXTo܂ł̃EFCgB */
		for(i = 0; i <= NEXT_WAIT; i++) {
			schedule();
			field_disp(0); /* ubN\Ȃ */
			gi.anm++;
		}
	}
GAMEOVER:
	/* 珇ɐΉAsBGMB */
	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(i = 0; i < SEC(0.05); i++) {
			schedule();
			field_disp(0); /* ubN\Ȃ */
			gi.anm++;
		}
		sound_play(2, LAND);
		for(col = 0; col < FIELD_COLS; col++) {
			if(gi.field[row][col]) gi.field[row][col] = 4; /* Ή */
		}
		pceWaveSetChAtt(0, ((FIELD_ROWS - 1) - row)  /* 0(FIELD_ROWS-1)    */
				   * 31 / (FIELD_ROWS - 1)); /* 031i1/4܂Ōj */
	}
	for(i = 32; i <= 127; i += 4) { /* c茸i܂Ⴂ܂j */
		schedule();
		pceWaveSetChAtt(0, i);
	}
	mod_stop(); /* BGM~ */
	pceWaveSetChAtt(0, 0); /* Ôߌ */

	/* tB[h܂B */
	memset(gi.field, 0, sizeof gi.field);

	/* uGAMEOVERv\B */
	for(i = 0; i < SEC(5); i++) {
		schedule();
		if(i >= SEC(2) && joy & (TRG_A | TRG_B)) break; /* Qbڈȍ~̓LZ */
		field_disp(0); /* ubN\ȂB */
		gi.anm++;
		render_string_framed(&render, 8, (DISP_Y - 10) / 2 + 1, "GAMEOVER", 0, 0x203);
	}

	/* nCXRAXVB */
	if(gi.score > hiscore) hiscore = gi.score;
}

/****************************************************************************
 *	cell_pos
 ****************************************************************************/

/* ubN̊eZ̃tB[hł̈ʒu߂܂B
 * [in]
 *	(bcol,brow)	ubN_̍sitB[h_΁j
 *	(ccol,crow)	Z̍siubN_΁j
 * [out]
 *	(*fcol,*frow)	Z̍sitB[h_΁j
 * [note]
 *	* ubN_tB[h̏ꍇiv̌^tB[hƃubNłĂꍇj́A
 *	  ubN̃Z͈̃tB[hsɓ܂B
 *	  Ȃ񂶁F
 *		@@@_^_^
 *		@@@_^_^
 *		@@@_^_^ubN
 *		@@@_^_^
 *		@@@_^_^
 *		_^_^_^_^_^ctB[hs
 */
void
cell_pos(int bcol, int brow, int ccol, int crow, int* fcol, int* frow)
{
	*fcol = bcol + ccol;
	*frow = brow + crow + (bcol & ccol & 1);
}

/****************************************************************************
 *	cell_disp
 ****************************************************************************/

/* tB[hubÑZ\܂B
 * ĂяoŁurender.context->texture = &patvĂĂB
 */
void
cell_disp(int col, int row, int type)
{
	int dx, dy, sx, sy;

	dx =    5                         + 4 * col;
	dy = (116 - (FIELD_ROWS - 1) * 6) + 6 * row;
	/*    ~~~Z̍W */
	if(col & 1) dy += 3; /* ͔L */

	sx = 0;
	sy = 0 + 8 * type;

	render_object(&render, dx, dy, sx, sy, 8, 7, DRW_NOMAL);
}

/****************************************************************************
 *	block_disp
 ****************************************************************************/

/* tB[hubN\܂B
 * ĂяoŁurender.context->texture = &patvĂĂB
 */
void
block_disp(int col, int row, const BLOCK block, int type)
{
	int ccol, crow, fcol, frow;

	for(crow = 0; crow < BLOCK_ROWS; crow++) {
		for(ccol = 0; ccol < BLOCK_COLS; ccol++) {
			if(block[crow][ccol]) {
				cell_pos(col, row, ccol, crow, &fcol, &frow);
				cell_disp(fcol, frow, type);
			}
		}
	}
}

/****************************************************************************
 *	center_disp
 ****************************************************************************/

void
center_disp(int col, int row, int type)
{
	int fcol, frow;
	int dx, dy, sx, sy;

	cell_pos(col, row, 2, 2, &fcol, &frow); /* ubN̒S(2,2) */

	dx =    5                         + 4 * fcol;
	dy = (116 - (FIELD_ROWS - 1) * 6) + 6 * frow;
	/*    ~~~Z̍W */
	if(col & 1) dy += 3; /* ͔L */

	sx = 8;
	sy = 0 + 8 * type;

	render_object(&render, dx, dy, sx, sy, 8, 7, DRW_NOMAL);
}

/****************************************************************************
 *	next_cell_disp
 ****************************************************************************/

/* NEXTubÑZ\܂B
 * ĂяoŁurender.context->texture = &patvĂĂB
 */
void
next_cell_disp(int col, int row, int type)
{
	int dx, dy, sx, sy;

	dx =  61                         + 4 * col;
	dy = (23 - (BLOCK_ROWS - 1) * 6) + 6 * row;
	/*    ~~~Z̍W */
	if(col & 1) dy += 3; /* ͔L */

	sx = 0;
	sy = 0 + 8 * type;

	render_object(&render, dx, dy, sx, sy, 8, 7, DRW_NOMAL);
}

/****************************************************************************
 *	next_block_disp
 ****************************************************************************/

/* NEXTubN\܂B
 * ĂяoŁurender.context->texture = &patvĂĂB
 */
void
next_block_disp(const BLOCK block)
{
	int col, row;

	for(row = 0; row < BLOCK_ROWS; row++) {
		for(col = 0; col < BLOCK_COLS; col++) {
			if(block[row][col]) {
				next_cell_disp(col, row, 0/*^CvŒ*/);
			}
		}
	}
}

/****************************************************************************
 *	block_rot
 ****************************************************************************/

/* ubN]܂B(rot=0:E]/1:]) */
void
block_rot(const BLOCK src, int rot, BLOCK dst)
{
	BLOCK tmp; /* src=dst̉\̂ŁAsrc-(])->tmp-(Rs[)->dst */
	int i, j, k, col1, row1, col2, row2;

	memcpy(tmp, src, sizeof(BLOCK)); /* ړȂẐŃRs[K{ */
	for(i = 0; i < 3; i++) {
		for(j = 0; j < 6; j++) {
			if(rot == 0) {
				k = j < 6 - 1 ? j + 1 : 0;
			} else {
				k = j > 0 ? j - 1 : 6 - 1;
			}
			col1 = rot_pos[i][j][0];
			row1 = rot_pos[i][j][1];
			col2 = rot_pos[i][k][0];
			row2 = rot_pos[i][k][1];
			tmp[row2][col2] = src[row1][col1];
		}
	}
	memcpy(dst, tmp, sizeof(BLOCK));
}

/****************************************************************************
 *	hit_test
 ****************************************************************************/

/* ubÑZtB[h̃ZɏdȂĂ邩AtB[hOȂ1Ԃ܂B
 * ubÑZSătB[hŁAdȂĂȂ΁A0Ԃ܂B
 */
int
hit_test(int col, int row, const BLOCK block)
{
	int ccol, crow, fcol, frow;

	for(crow = BLOCK_ROWS - 1; crow >= 0; crow--) {
		for(ccol = BLOCK_COLS - 1; ccol >= 0; ccol--) {
			if(!block[crow][ccol]) continue; /* ubN̋ʒu͔΂ */
			cell_pos(col, row, ccol, crow, &fcol, &frow);
			if(fcol < 0 || FIELD_COLS - 1 < fcol) return 1;
			if(frow < 0 || FIELD_ROWS - 1 < frow) return 1;
			if(gi.field[frow][fcol]) return 1;
		}
	}

	return 0;
}

/****************************************************************************
 *	land_test
 ****************************************************************************/

/* ubNZtB[h̒ɐڒnĂA1Ԃ܂B */
int
land_test(int col, int row, const BLOCK block)
{
	int ccol, crow, fcol, frow;

	for(crow = 0; crow < BLOCK_ROWS; crow++) {
		for(ccol = 0; ccol < BLOCK_COLS; ccol++) {
			if(!block[crow][ccol]) continue; /* ubN̋ʒu͔΂ */
			cell_pos(col, row, ccol, crow, &fcol, &frow);
			if(frow == FIELD_ROWS - 1) return 1;
			if(gi.field[frow + 1][fcol]) return 1;
		}
	}

	return 0;
}

/****************************************************************************
 *	block_put
 ****************************************************************************/

/* tB[hɃubN̉܂B */
void
block_put(int col, int row, const BLOCK block)
{
	int ccol, crow, fcol, frow;

	for(crow = 0; crow < BLOCK_ROWS; crow++) {
		for(ccol = 0; ccol < BLOCK_COLS; ccol++) {
			if(!block[crow][ccol]) continue; /* ubN̋ʒu͔΂ */
			cell_pos(col, row, ccol, crow, &fcol, &frow);
			gi.field[frow][fcol] = 1;
		}
	}
}

/****************************************************************************
 *	block_work
 ****************************************************************************/

void
block_work()
{
	int i, rot, mov;
	BLOCK tmp;

	/* ]... */
	rot = -1; /* ܂]ȂɂĂ */
	if(joy &  TRG_A          ) rot = 0; /* E] */
	if(joy & (TRG_B | TRG_UP)) rot = 1; /* ]iЎŗVׂ悤ɁA{^]ɊĂ܂j */
	if(rot != -1) { /* Eǂ炩ւ̉]vꂽ... */
		/* ̂܂܂̈ʒu(i=0)ŉ]ł΂̂܂܂̈ʒuŉ]B
		 * _ȂËʒu܂Ŏł炵Ă݂B
		 */
		block_rot(gi.block, rot, tmp);
		for(i = 0; i <= 1; i++) {
			if(!hit_test(gi.col - i, gi.row, tmp)) {
				memcpy(gi.block, tmp, sizeof(BLOCK));
				gi.col -= i;
				sound_play(1, ROT);
				break;
			}
			if(!hit_test(gi.col + i, gi.row, tmp)) { /* i=0̏ꍇA̓_~[ł */
				memcpy(gi.block, tmp, sizeof(BLOCK));
				gi.col += i;
				sound_play(1, ROT);
				break;
			}
		}
	}

	/* ړ... */
	mov = 0; /* ܂ړȂɂĂB */
	if(joy & TRG_LF) mov = -1; /* ړ */
	if(joy & TRG_RI) mov =  1; /* Eړ */
	if(mov != 0) {
		if(!hit_test(gi.col + mov, gi.row, gi.block)) {
			gi.col += mov;
		} else {
			if(gi.col & 1) {
				/* 񁨋̈ړ͔LoȂ̂ŁAeXg܂B */
				if(!hit_test(gi.col + mov, gi.row + 1, gi.block)) {
					gi.col += mov;
					gi.row++;
				}
			} else {
				/* 񁨊̈ړ͔LȂ̂ŁAoeXg܂B */
				if(!hit_test(gi.col + mov, gi.row - 1, gi.block)) {
					gi.col += mov;
					gi.row--;
				}
			}
		}
	}
}

/****************************************************************************
 *	line_test
 ****************************************************************************/

/* sC̒l12ɕύX܂B
 * ߂ĺAs̐łB
 */
int
line_test()
{
	int cnt, col, row;

	cnt = 0;
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			/* ł󔒂΁AĂ܂B */
			if(!gi.field[row][col]) break;
		}
		/* Ăl2ɕύXAJEgAbv܂B */
		if(col == FIELD_COLS) {
			for(col = 0; col < FIELD_COLS; col++) {
				gi.field[row][col] = 2;
			}
			cnt++;
		}
	}

	return cnt;
}

/****************************************************************************
 *	line_erase
 ****************************************************************************/

/* sC܂B */
void
line_erase()
{
	int i, col, row;

	/* Ƃ͉Ȃ̂ŁAƍł܂A
	 * ͍vȂ̂ŁAPʂŒPɑg݂܂B
	 */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			/* ̃ZĂ... */
			if(gi.field[row][col] >= 2) {
				/* ܂B */
				//gi.field[row][col] = 0;svł
				/* ォ痎ƂB */
				for(i = row; i > 0; i--) {
					gi.field[i][col] = gi.field[i - 1][col];
				}
				/* ΂̍s󂫂܂B */
				gi.field[i][col] = 0;
			}
		}
	}
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

static const char center_ptn[16] = { 0,0,1,1, 2,2,3,3, 4,4,3,3, 2,2,1,1 };

/* tB[h`܂B */
void
field_disp(int show_block)
{
	int col, row, type;

	/* wi\B */
	render_save(&render);
	render.context->texture = &bg;
	render_object(&render, 0, 0, 0, 0, DISP_X, DISP_Y, DRW_NOMAL);
	render_restore(&render);

	/* tB[hZ\B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			type = gi.field[row][col];
			if(!type) continue;
			switch(type) {
			case 1: /* ʏ */
				type = row & 1 ? 1 : 2;
				break;
			case 2: /* Łi\j */
				if(gi.anm % SEC(0.2) < SEC(0.1)) {
					type = row & 1 ? 1 : 2;
				} else {
					type = 3;
				}
				break;
			case 3: /* Łi\Ȃj */
				type = -1;
				break;
			case 4: /* Ή */
				type = 4;
				break;
			default:
				DIE();
			}
			if(type != -1) cell_disp(col, row, type);
		}
	}

	/* ݂̃ubN\B */
	if(show_block) {
		/* nn_̃qg\B */
		if(LEVEL_HINT) {
			col = gi.col;
			for(row = gi.row; row < FIELD_ROWS; row++) {
				if(land_test(col, row, gi.block)) break;
			}
			if(gi.anm % SEC(0.2) < SEC(0.1)) {
				block_disp(col, row, gi.block, 5);
			}
		}
		/* ubN\B */
		block_disp(gi.col, gi.row, gi.block, 0);
		center_disp(gi.col, gi.row, center_ptn[gi.anm % 16]);
	}

	/* ŏ㕔}XN\B */
	row = OUTER_ROWS - 1;
	for(col = 1; col < FIELD_COLS; col += 2) {
		cell_disp(col, row, 6);
	}

	/* NEXTubN\B */
	next_block_disp(blocks[gi.next]);

	/* CtH[V\B */
	render_printf(&render, 62, 52, 2, 0, "%6d", gi.score <= 999999 ? gi.score : 999999);
	render_printf(&render, 62, 66, 2, 0, "%6d", gi.lines <= 999999 ? gi.lines : 999999);
	render_printf(&render, 62, 80, 2, 0, "%6d", gi.level <= 999999 ? gi.level : 999999);
}
